unit UPerlinTerrainDemo;
{ ============================================================================= }
{                        UNIT UPerlinTerrainDemo                                }
{                                                                               }
{  Description : Demonstrates the mysterious GLPerlin unit. Generates a mountain}
{ as per suggestion by Joen Joenson. Perlin noise can be used to make natural   }
{ looking objects like ocean waves, mountains, textures (eg wood, marble) and   }
{ the great thing is they dont require big bitmap files or 3D structure files.  }
{ More info about perlin noise at:                                              }
{ http://freespace.virgin.net/hugo.elias/models/m_perlin.htm                    }
{                                                                               }
{ Create May 2004 Skinhat                                                       }
{                                                                               }
{ ============================================================================= }
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  GLScene, GLObjects, GLWin32Viewer, GLMisc, GLHeightData,
  GLTerrainRenderer, jpeg, GLTexture, StdCtrls,vectorgeometry, GLCadencer,
  GLGeomObjects, GLVectorFileObjects, GLMesh, GLTexCombineShader,
  ComCtrls, glperlin, GLBumpmapHDS;


type
  TForm1 = class(TForm)
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLCamera: TGLCamera;
    GLTerrainRenderer1: TGLTerrainRenderer;
    GLMaterialLibrary1: TGLMaterialLibrary;
    GLCadencer1: TGLCadencer;
    GLBumpmapHDS1: TGLBumpmapHDS;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GLCadencer1Progress(Sender: TObject; const deltaTime,
      newTime: Double);
    procedure GLBumpmapHDS1NewTilePrepared(Sender: TGLBumpmapHDS;
      heightData: THeightData; normalMapMaterial: TGLLibMaterial);
    procedure FormDestroy(Sender: TObject);

  private
    { Private declarations }

    glperlinhds:tglperlinhds;
  public
    { Public declarations }

  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  glperlinhds:=TGLPerlinhds.create(nil);
  glperlinhds.Persistence:=0.5;
  glperlinhds.Number_Of_Octaves:=6;
  GLBumpmapHDS1.ElevationHDS:=glperlinhds;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  glperlinhds.free;
end;


procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  factor:double;
begin
  if (ssshift in shift) then
    factor:=4
  else
    factor:=2;
  case key of
    35,40: glcamera.move(-0.5*factor);
    37: begin
        glcamera.turn(-5*factor);

      end;
    39: begin
        glcamera.turn(5*factor);

      end;
    38,65,16: glcamera.move(0.5*factor);
    33:  glcamera.pitch(2*factor);
    34:  glcamera.pitch(-1*factor);

  end;

  glcamera.position.y:=0.2+glterrainrenderer1.InterpolatedHeight(glcamera.position.asvector);


end;

procedure TForm1.GLCadencer1Progress(Sender: TObject; const deltaTime,
  newTime: Double);
begin
  caption:=Format('%.2f FPS x%.2f,y%.2f,z%.2f',  [GLSceneViewer1.FramesPerSecond,glcamera.position.x,glcamera.position.y,glcamera.position.x,glcamera.position.z]);
end;

procedure TForm1.GLBumpmapHDS1NewTilePrepared(Sender: TGLBumpmapHDS;
  heightData: THeightData; normalMapMaterial: TGLLibMaterial);
var
   n : TVector;
begin
   heightData.MaterialName:=normalMapMaterial.Name;
  // normalMapMaterial.Shader:=GLTexCombineShader1;
   normalMapMaterial.Material.MaterialOptions:=[moNoLighting];
   (*n:=VectorNormalize({SPSun}VectorMake(0,100,0){GLLightSource1.AbsolutePosition});
   ScaleVector(n, 0.5);
   n[1]:=-n[1];
   n[2]:=-n[2];
   AddVector(n , 0.5);
   normalMapMaterial.Material.FrontProperties.Diffuse.Color:=n;      *)
end;

end.
